﻿Imports System.ComponentModel
Class Order
    Implements IDataErrorInfo, INotifyPropertyChanged
    Private _id As Int32
    Private _d As DateTime
    Private _wc As Boolean
    Public Property id As Int32
        Get
            Return _id
        End Get
        Set(ByVal value As Int32)
            _id = value
            onPropertyChanged("id")
        End Set
    End Property
    Public Property d As DateTime
        Get
            Return _d
        End Get
        Set(ByVal value As DateTime)
            _d = value
            onPropertyChanged("date")
        End Set
    End Property
    Public Property wc As Boolean
        Get
            Return _wc
        End Get
        Set(ByVal value As Boolean)
            _wc = value
            onPropertyChanged("wc")
        End Set
    End Property

    Public Sub New()
        AddHandler Me.PropertyChanged, AddressOf Me.validateData
    End Sub
    Public Sub validateData(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
        If sender Is Nothing Then
            AddError(e.PropertyName, e.PropertyName & " is blank")
        Else
            RemoveError(e.PropertyName, e.PropertyName & " is blank")
        End If
    End Sub
    Public Sub collectionValidation()
        Dim x = 1
    End Sub

    Public errorDict As New Dictionary(Of String, List(Of String))
    Public ReadOnly Property [Error] As String Implements System.ComponentModel.IDataErrorInfo.Error
        Get
            Dim errorString As String = String.Empty
            For Each clm In errorDict
                For Each err As String In clm.Value
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            Next
            Return errorString
        End Get
    End Property
    Default Public ReadOnly Property Item(ByVal columnName As String) As String Implements System.ComponentModel.IDataErrorInfo.Item
        Get
            Dim errorString As String = String.Empty
            If errorDict.ContainsKey(columnName) Then
                For Each err As String In errorDict(columnName)
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            End If
            Return errorString
        End Get
    End Property
    Public Sub AddError(ByVal propertyName As String, ByVal [error] As String)
        If Not errorDict.ContainsKey(propertyName) Then
            errorDict(propertyName) = New List(Of String)()
        End If

        If Not errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Insert(0, [error])
        End If
    End Sub
    Public Sub RemoveError(ByVal propertyName As String, ByVal [error] As String)
        If errorDict.ContainsKey(propertyName) AndAlso errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Remove([error])
            If errorDict(propertyName).Count = 0 Then
                errorDict.Remove(propertyName)
            End If
        End If
    End Sub

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
    Public Sub onPropertyChanged(ByVal e As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(e))
    End Sub

End Class
Class OrderItem
    Implements IDataErrorInfo, INotifyPropertyChanged
    Private _oid As Int32
    Private _qty As Int32
    Private _iid As Int32
    Public Property oid As Int32
        Get
            Return _oid
        End Get
        Set(ByVal value As Int32)
            _oid = value
            onPropertyChanged("oid")
        End Set
    End Property
    Public Property qty As Int32
        Get
            Return _qty
        End Get
        Set(ByVal value As Int32)
            _qty = value
            onPropertyChanged("qty")
        End Set
    End Property
    Public Property iid As Int32
        Get
            Return _iid
        End Get
        Set(ByVal value As Int32)
            _iid = value
            onPropertyChanged("iid")
        End Set
    End Property

    Public Sub New()
        AddHandler Me.PropertyChanged, AddressOf Me.validateData
    End Sub
    Public Sub validateData(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
        If sender Is Nothing Then
            AddError(e.PropertyName, e.PropertyName & " is blank")
        Else
            RemoveError(e.PropertyName, e.PropertyName & " is blank")
        End If
    End Sub
    Public Sub collectionValidation()
        Dim x = 1
    End Sub

    Public errorDict As New Dictionary(Of String, List(Of String))
    Public ReadOnly Property [Error] As String Implements System.ComponentModel.IDataErrorInfo.Error
        Get
            Dim errorString As String = String.Empty
            For Each clm In errorDict
                For Each err As String In clm.Value
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            Next
            Return errorString
        End Get
    End Property
    Default Public ReadOnly Property Item(ByVal columnName As String) As String Implements System.ComponentModel.IDataErrorInfo.Item
        Get
            Dim errorString As String = String.Empty
            If errorDict.ContainsKey(columnName) Then
                For Each err As String In errorDict(columnName)
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            End If
            Return errorString
        End Get
    End Property
    Public Sub AddError(ByVal propertyName As String, ByVal [error] As String)
        If Not errorDict.ContainsKey(propertyName) Then
            errorDict(propertyName) = New List(Of String)()
        End If

        If Not errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Insert(0, [error])
        End If
    End Sub
    Public Sub RemoveError(ByVal propertyName As String, ByVal [error] As String)
        If errorDict.ContainsKey(propertyName) AndAlso errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Remove([error])
            If errorDict(propertyName).Count = 0 Then
                errorDict.Remove(propertyName)
            End If
        End If
    End Sub

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
    Public Sub onPropertyChanged(ByVal e As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(e))
    End Sub
End Class
Class Inventory
    Implements IDataErrorInfo, INotifyPropertyChanged
    Private _id As Int32
    Private _name As String
    Private _descr As String
    Public Property id As Int32
        Get
            Return _id
        End Get
        Set(ByVal value As Int32)
            _id = value
            onPropertyChanged("id")
        End Set
    End Property
    Public Property name As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
            onPropertyChanged("name")
        End Set
    End Property
    Public Property descr As String
        Get
            Return _descr
        End Get
        Set(ByVal value As String)
            _descr = value
            onPropertyChanged("descr")
        End Set
    End Property

    Public Sub New()
        AddHandler Me.PropertyChanged, AddressOf Me.validateData
    End Sub
    Public Sub validateData(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
        Dim val = sender.GetType.GetProperty(e.PropertyName).GetValue(sender, Nothing)
        If val Is Nothing Then
            AddError(e.PropertyName, e.PropertyName & " is blank")
        Else
            RemoveError(e.PropertyName, e.PropertyName & " is blank")
        End If

    End Sub
    Public Sub collectionValidation()
        Dim x = 1
    End Sub

    Public errorDict As New Dictionary(Of String, List(Of String))
    Public ReadOnly Property [Error] As String Implements System.ComponentModel.IDataErrorInfo.Error
        Get
            Dim errorString As String = String.Empty
            For Each clm In errorDict
                For Each err As String In clm.Value
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            Next
            Return errorString
        End Get
    End Property
    Default Public ReadOnly Property Item(ByVal columnName As String) As String Implements System.ComponentModel.IDataErrorInfo.Item
        Get
            Dim errorString As String = String.Empty
            If errorDict.ContainsKey(columnName) Then
                For Each err As String In errorDict(columnName)
                    errorString += err & vbCrLf
                Next
                errorString = errorString.Remove(errorString.LastIndexOf(vbCrLf))
            End If
            Return errorString
        End Get
    End Property
    Public Sub AddError(ByVal propertyName As String, ByVal [error] As String)
        If Not errorDict.ContainsKey(propertyName) Then
            errorDict(propertyName) = New List(Of String)()
        End If

        If Not errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Insert(0, [error])
        End If
    End Sub
    Public Sub RemoveError(ByVal propertyName As String, ByVal [error] As String)
        If errorDict.ContainsKey(propertyName) AndAlso errorDict(propertyName).Contains([error]) Then
            errorDict(propertyName).Remove([error])
            If errorDict(propertyName).Count = 0 Then
                errorDict.Remove(propertyName)
            End If
        End If
    End Sub
    Public Function hasError(ByVal propertyName As String) As Boolean
        Dim result As Boolean = False
        If errorDict.ContainsKey(propertyName) Then
            result = True
        End If
        Return result
    End Function

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
    Public Sub onPropertyChanged(ByVal e As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(e))
    End Sub
End Class